/*  GNU Pascal Interface to SDL. 
    Copyright (C) 2002 by Eike Lange
    
    This unit is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This unit is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Eike Lange, eike@gnu.de
    http://www.gnu-pascal.de/~contrib/eike/
*/


#include <SDL/SDL.h>

/* From SDL.h */
int _p_sdl_init_timer       = SDL_INIT_TIMER;
int _p_sdl_init_audio       = SDL_INIT_AUDIO;
int _p_sdl_init_video       = SDL_INIT_VIDEO;
int _p_sdl_init_cdrom       = SDL_INIT_CDROM;
int _p_sdl_init_joystick    = SDL_INIT_JOYSTICK;
int _p_sdl_init_noparachute = SDL_INIT_NOPARACHUTE;
int _p_sdl_init_eventthread = SDL_INIT_EVENTTHREAD;
int _p_sdl_init_everything  = SDL_INIT_EVERYTHING;


/* From SDL_active.h */
int _p_sdl_appmousefocus    = SDL_APPMOUSEFOCUS;
int _p_sdl_appinputfocus    = SDL_APPINPUTFOCUS;
int _p_sdl_appactive        = SDL_APPACTIVE;

/* From SDL_event.h */
int _p_sizeof_SDL_ActiveEvent (void) { return sizeof (SDL_ActiveEvent); }
int _p_sizeof_SDL_KeyboardEvent (void) { return sizeof (SDL_KeyboardEvent); }
int _p_sizeof_SDL_MouseMotionEvent (void) { return sizeof (SDL_MouseMotionEvent); }
int _p_sizeof_SDL_MouseButtonEvent (void) { return sizeof (SDL_MouseButtonEvent); }
int _p_sizeof_SDL_JoyAxisEvent (void) { return sizeof (SDL_JoyAxisEvent ); }
int _p_sizeof_SDL_JoyBallEvent (void) { return sizeof (SDL_JoyBallEvent); }
int _p_sizeof_SDL_JoyHatEvent (void) { return sizeof (SDL_JoyHatEvent); }
int _p_sizeof_SDL_JoyButtonEvent (void) { return sizeof (SDL_JoyButtonEvent); }
int _p_sizeof_SDL_ResizeEvent (void) { return sizeof (SDL_ResizeEvent); }
int _p_sizeof_SDL_ExposeEvent (void) { return sizeof (SDL_ExposeEvent); }
int _p_sizeof_SDL_QuitEvent (void) { return sizeof (SDL_QuitEvent); }
int _p_sizeof_SDL_UserEvent (void) { return sizeof (SDL_UserEvent); }
int _p_sizeof_SDL_SysWMEvent (void) { return sizeof (SDL_SysWMEvent); }
int _p_sizeof_SDL_Event (void) { return sizeof (SDL_Event); }
int _p_sizeof_SDL_eventaction (void) { return sizeof (SDL_eventaction); }

int _p_sdl_eventmask (int X) { return (SDL_EVENTMASK (X)); }

int _p_sdl_NOEVENT      = SDL_NOEVENT;
int _p_sdl_ACTIVEEVENT  = SDL_ACTIVEEVENT;
int _p_sdl_KEYDOWN      = SDL_KEYDOWN;
int _p_sdl_KEYUP        = SDL_KEYUP;
int _p_sdl_MOUSEMOTION  = SDL_MOUSEMOTION;
int _p_sdl_MOUSEBUTTONDOWN  = SDL_MOUSEBUTTONDOWN;
int _p_sdl_MOUSEBUTTONUP  = SDL_MOUSEBUTTONUP;
int _p_sdl_JOYAXISMOTION  = SDL_JOYAXISMOTION;
int _p_sdl_JOYBALLMOTION  = SDL_JOYBALLMOTION;
int _p_sdl_JOYHATMOTION   = SDL_JOYHATMOTION;
int _p_sdl_JOYBUTTONDOWN  = SDL_JOYBUTTONDOWN;
int _p_sdl_JOYBUTTONUP    = SDL_JOYBUTTONUP;
int _p_sdl_QUIT           = SDL_QUIT;
int _p_sdl_SYSWMEVENT     = SDL_SYSWMEVENT;
int _p_sdl_EVENT_RESERVEDA  = SDL_EVENT_RESERVEDA;
int _p_sdl_EVENT_RESERVEDB  = SDL_EVENT_RESERVEDB;
int _p_sdl_VIDEORESIZE    = SDL_VIDEORESIZE;
int _p_sdl_VIDEOEXPOSE    = SDL_VIDEOEXPOSE;
int _p_sdl_EVENT_RESERVED2  = SDL_EVENT_RESERVED2;
int _p_sdl_EVENT_RESERVED3  = SDL_EVENT_RESERVED3;
int _p_sdl_EVENT_RESERVED4  = SDL_EVENT_RESERVED4;
int _p_sdl_EVENT_RESERVED5  = SDL_EVENT_RESERVED5;
int _p_sdl_EVENT_RESERVED6  = SDL_EVENT_RESERVED6;
int _p_sdl_EVENT_RESERVED7  = SDL_EVENT_RESERVED7;
int _p_sdl_USEREVENT  = SDL_USEREVENT;
int _p_sdl_NUMEVENTS  = SDL_NUMEVENTS;
int _p_sdl_ACTIVEEVENTMASK      = SDL_ACTIVEEVENTMASK;
int _p_sdl_KEYDOWNMASK          = SDL_KEYDOWNMASK;
int _p_sdl_KEYUPMASK            = SDL_KEYUPMASK;
int _p_sdl_MOUSEMOTIONMASK      = SDL_MOUSEMOTIONMASK;
int _p_sdl_MOUSEBUTTONDOWNMASK  = SDL_MOUSEBUTTONDOWNMASK;
int _p_sdl_MOUSEBUTTONUPMASK    = SDL_MOUSEBUTTONUPMASK;
int _p_sdl_MOUSEEVENTMASK       = SDL_MOUSEEVENTMASK;
int _p_sdl_JOYAXISMOTIONMASK    = SDL_JOYAXISMOTIONMASK;
int _p_sdl_JOYBALLMOTIONMASK    = SDL_JOYBALLMOTIONMASK;
int _p_sdl_JOYHATMOTIONMASK     = SDL_JOYHATMOTIONMASK;
int _p_sdl_JOYBUTTONDOWNMASK    = SDL_JOYBUTTONDOWNMASK;
int _p_sdl_JOYBUTTONUPMASK      = SDL_JOYBUTTONUPMASK;
int _p_sdl_JOYEVENTMASK         = SDL_JOYEVENTMASK;
int _p_sdl_VIDEORESIZEMASK      = SDL_VIDEORESIZEMASK;
int _p_sdl_VIDEOEXPOSEMASK      = SDL_VIDEOEXPOSEMASK;
int _p_sdl_QUITMASK             = SDL_QUITMASK;
int _p_sdl_SYSWMEVENTMASK       = SDL_SYSWMEVENTMASK;
int _p_sdl_ALLEVENTS            = SDL_ALLEVENTS;
int _p_sdl_query    = SDL_QUERY;
int _p_sdl_ignore   = SDL_IGNORE;
int _p_sdl_disable  = SDL_DISABLE;
int _p_sdl_enable   = SDL_ENABLE;

int _p_sdl_addevent   = SDL_ADDEVENT;
int _p_sdl_peekevent  = SDL_PEEKEVENT;
int _p_sdl_getevent   = SDL_GETEVENT;

/* From SDL_keyboard.h */
int _p_sizeof_SDL_keysym (void) { return sizeof (SDL_keysym); }

int _p_sdl_all_hotkeys = SDL_ALL_HOTKEYS;
int _p_sdl_default_repeat_delay = SDL_DEFAULT_REPEAT_DELAY;
int _p_sdl_default_repeat_interval = SDL_DEFAULT_REPEAT_INTERVAL;

/* From SDL_keysym.h */
int _p_sizeof_SDLKey (void) { return sizeof (SDLKey); }
int _p_sizeof_SDLMod (void) { return sizeof (SDLMod); }

int _p_sdlk_UNKNOWN  = SDLK_UNKNOWN;
int _p_sdlk_FIRST  = SDLK_FIRST;
int _p_sdlk_BACKSPACE  = SDLK_BACKSPACE;
int _p_sdlk_TAB  = SDLK_TAB;
int _p_sdlk_CLEAR  = SDLK_CLEAR;
int _p_sdlk_RETURN  = SDLK_RETURN;
int _p_sdlk_PAUSE  = SDLK_PAUSE;
int _p_sdlk_ESCAPE  = SDLK_ESCAPE;
int _p_sdlk_SPACE  = SDLK_SPACE;
int _p_sdlk_EXCLAIM  = SDLK_EXCLAIM;
int _p_sdlk_QUOTEDBL  = SDLK_QUOTEDBL;
int _p_sdlk_HASH  = SDLK_HASH;
int _p_sdlk_DOLLAR  = SDLK_DOLLAR;
int _p_sdlk_AMPERSAND  = SDLK_AMPERSAND;
int _p_sdlk_QUOTE  = SDLK_QUOTE;
int _p_sdlk_LEFTPAREN  = SDLK_LEFTPAREN;
int _p_sdlk_RIGHTPAREN  = SDLK_RIGHTPAREN;
int _p_sdlk_ASTERISK  = SDLK_ASTERISK;
int _p_sdlk_PLUS  = SDLK_PLUS;
int _p_sdlk_COMMA  = SDLK_COMMA;
int _p_sdlk_MINUS  = SDLK_MINUS;
int _p_sdlk_PERIOD  = SDLK_PERIOD;
int _p_sdlk_SLASH  = SDLK_SLASH;
int _p_sdlk_0  = SDLK_0;
int _p_sdlk_1  = SDLK_1;
int _p_sdlk_2  = SDLK_2;
int _p_sdlk_3  = SDLK_3;
int _p_sdlk_4  = SDLK_4;
int _p_sdlk_5  = SDLK_5;
int _p_sdlk_6  = SDLK_6;
int _p_sdlk_7  = SDLK_7;
int _p_sdlk_8  = SDLK_8;
int _p_sdlk_9  = SDLK_9;
int _p_sdlk_COLON  = SDLK_COLON;
int _p_sdlk_SEMICOLON  = SDLK_SEMICOLON;
int _p_sdlk_LESS  = SDLK_LESS;
int _p_sdlk_EQUALS  = SDLK_EQUALS;
int _p_sdlk_GREATER  = SDLK_GREATER;
int _p_sdlk_QUESTION  = SDLK_QUESTION;
int _p_sdlk_AT  = SDLK_AT;
int _p_sdlk_LEFTBRACKET	= SDLK_LEFTBRACKET;
int _p_sdlk_BACKSLASH  = SDLK_BACKSLASH;
int _p_sdlk_RIGHTBRACKET = SDLK_RIGHTBRACKET;
int _p_sdlk_CARET  = SDLK_CARET;
int _p_sdlk_UNDERSCORE  = SDLK_UNDERSCORE;
int _p_sdlk_BACKQUOTE  = SDLK_BACKQUOTE;
int _p_sdlk_a  = SDLK_a;
int _p_sdlk_b  = SDLK_b;
int _p_sdlk_c  = SDLK_c;
int _p_sdlk_d  = SDLK_d;
int _p_sdlk_e  = SDLK_e;
int _p_sdlk_f  = SDLK_f;
int _p_sdlk_g  = SDLK_g;
int _p_sdlk_h  = SDLK_h;
int _p_sdlk_i  = SDLK_i;
int _p_sdlk_j  = SDLK_j;
int _p_sdlk_k  = SDLK_k;
int _p_sdlk_l  = SDLK_l;
int _p_sdlk_m  = SDLK_m;
int _p_sdlk_n  = SDLK_n;
int _p_sdlk_o  = SDLK_o;
int _p_sdlk_p  = SDLK_p;
int _p_sdlk_q  = SDLK_q;
int _p_sdlk_r  = SDLK_r;
int _p_sdlk_s  = SDLK_s;
int _p_sdlk_t  = SDLK_t;
int _p_sdlk_u  = SDLK_u;
int _p_sdlk_v  = SDLK_v;
int _p_sdlk_w  = SDLK_w;
int _p_sdlk_x  = SDLK_x;
int _p_sdlk_y  = SDLK_y;
int _p_sdlk_z  = SDLK_z;
int _p_sdlk_DELETE  = SDLK_DELETE;
int _p_sdlk_WORLD_0  = SDLK_WORLD_0;
int _p_sdlk_WORLD_1  = SDLK_WORLD_1;
int _p_sdlk_WORLD_2  = SDLK_WORLD_2;
int _p_sdlk_WORLD_3  = SDLK_WORLD_3;
int _p_sdlk_WORLD_4  = SDLK_WORLD_4;
int _p_sdlk_WORLD_5  = SDLK_WORLD_5;
int _p_sdlk_WORLD_6  = SDLK_WORLD_6;
int _p_sdlk_WORLD_7  = SDLK_WORLD_7;
int _p_sdlk_WORLD_8  = SDLK_WORLD_8;
int _p_sdlk_WORLD_9  = SDLK_WORLD_9;
int _p_sdlk_WORLD_10  = SDLK_WORLD_10;
int _p_sdlk_WORLD_11  = SDLK_WORLD_11;
int _p_sdlk_WORLD_12  = SDLK_WORLD_12;
int _p_sdlk_WORLD_13  = SDLK_WORLD_13;
int _p_sdlk_WORLD_14  = SDLK_WORLD_14;
int _p_sdlk_WORLD_15  = SDLK_WORLD_15;
int _p_sdlk_WORLD_16  = SDLK_WORLD_16;
int _p_sdlk_WORLD_17  = SDLK_WORLD_17;
int _p_sdlk_WORLD_18  = SDLK_WORLD_18;
int _p_sdlk_WORLD_19  = SDLK_WORLD_19;
int _p_sdlk_WORLD_20  = SDLK_WORLD_20;
int _p_sdlk_WORLD_21  = SDLK_WORLD_21;
int _p_sdlk_WORLD_22  = SDLK_WORLD_22;
int _p_sdlk_WORLD_23  = SDLK_WORLD_23;
int _p_sdlk_WORLD_24  = SDLK_WORLD_24;
int _p_sdlk_WORLD_25  = SDLK_WORLD_25;
int _p_sdlk_WORLD_26  = SDLK_WORLD_26;
int _p_sdlk_WORLD_27  = SDLK_WORLD_27;
int _p_sdlk_WORLD_28  = SDLK_WORLD_28;
int _p_sdlk_WORLD_29  = SDLK_WORLD_29;
int _p_sdlk_WORLD_30  = SDLK_WORLD_30;
int _p_sdlk_WORLD_31  = SDLK_WORLD_31;
int _p_sdlk_WORLD_32  = SDLK_WORLD_32;
int _p_sdlk_WORLD_33  = SDLK_WORLD_33;
int _p_sdlk_WORLD_34  = SDLK_WORLD_34;
int _p_sdlk_WORLD_35  = SDLK_WORLD_35;
int _p_sdlk_WORLD_36  = SDLK_WORLD_36;
int _p_sdlk_WORLD_37  = SDLK_WORLD_37;
int _p_sdlk_WORLD_38  = SDLK_WORLD_38;
int _p_sdlk_WORLD_39  = SDLK_WORLD_39;
int _p_sdlk_WORLD_40  = SDLK_WORLD_40;
int _p_sdlk_WORLD_41  = SDLK_WORLD_41;
int _p_sdlk_WORLD_42  = SDLK_WORLD_42;
int _p_sdlk_WORLD_43  = SDLK_WORLD_43;
int _p_sdlk_WORLD_44  = SDLK_WORLD_44;
int _p_sdlk_WORLD_45  = SDLK_WORLD_45;
int _p_sdlk_WORLD_46  = SDLK_WORLD_46;
int _p_sdlk_WORLD_47  = SDLK_WORLD_47;
int _p_sdlk_WORLD_48  = SDLK_WORLD_48;
int _p_sdlk_WORLD_49  = SDLK_WORLD_49;
int _p_sdlk_WORLD_50  = SDLK_WORLD_50;
int _p_sdlk_WORLD_51  = SDLK_WORLD_51;
int _p_sdlk_WORLD_52  = SDLK_WORLD_52;
int _p_sdlk_WORLD_53  = SDLK_WORLD_53;
int _p_sdlk_WORLD_54  = SDLK_WORLD_54;
int _p_sdlk_WORLD_55  = SDLK_WORLD_55;
int _p_sdlk_WORLD_56  = SDLK_WORLD_56;
int _p_sdlk_WORLD_57  = SDLK_WORLD_57;
int _p_sdlk_WORLD_58  = SDLK_WORLD_58;
int _p_sdlk_WORLD_59  = SDLK_WORLD_59;
int _p_sdlk_WORLD_60  = SDLK_WORLD_60;
int _p_sdlk_WORLD_61  = SDLK_WORLD_61;
int _p_sdlk_WORLD_62  = SDLK_WORLD_62;
int _p_sdlk_WORLD_63  = SDLK_WORLD_63;
int _p_sdlk_WORLD_64  = SDLK_WORLD_64;
int _p_sdlk_WORLD_65  = SDLK_WORLD_65;
int _p_sdlk_WORLD_66  = SDLK_WORLD_66;
int _p_sdlk_WORLD_67  = SDLK_WORLD_67;
int _p_sdlk_WORLD_68  = SDLK_WORLD_68;
int _p_sdlk_WORLD_69  = SDLK_WORLD_69;
int _p_sdlk_WORLD_70  = SDLK_WORLD_70;
int _p_sdlk_WORLD_71  = SDLK_WORLD_71;
int _p_sdlk_WORLD_72  = SDLK_WORLD_72;
int _p_sdlk_WORLD_73  = SDLK_WORLD_73;
int _p_sdlk_WORLD_74  = SDLK_WORLD_74;
int _p_sdlk_WORLD_75  = SDLK_WORLD_75;
int _p_sdlk_WORLD_76  = SDLK_WORLD_76;
int _p_sdlk_WORLD_77  = SDLK_WORLD_77;
int _p_sdlk_WORLD_78  = SDLK_WORLD_78;
int _p_sdlk_WORLD_79  = SDLK_WORLD_79;
int _p_sdlk_WORLD_80  = SDLK_WORLD_80;
int _p_sdlk_WORLD_81  = SDLK_WORLD_81;
int _p_sdlk_WORLD_82  = SDLK_WORLD_82;
int _p_sdlk_WORLD_83  = SDLK_WORLD_83;
int _p_sdlk_WORLD_84  = SDLK_WORLD_84;
int _p_sdlk_WORLD_85  = SDLK_WORLD_85;
int _p_sdlk_WORLD_86  = SDLK_WORLD_86;
int _p_sdlk_WORLD_87  = SDLK_WORLD_87;
int _p_sdlk_WORLD_88  = SDLK_WORLD_88;
int _p_sdlk_WORLD_89  = SDLK_WORLD_89;
int _p_sdlk_WORLD_90  = SDLK_WORLD_90;
int _p_sdlk_WORLD_91  = SDLK_WORLD_91;
int _p_sdlk_WORLD_92  = SDLK_WORLD_92;
int _p_sdlk_WORLD_93  = SDLK_WORLD_93;
int _p_sdlk_WORLD_94  = SDLK_WORLD_94;
int _p_sdlk_WORLD_95  = SDLK_WORLD_95;
int _p_sdlk_KP0  = SDLK_KP0;
int _p_sdlk_KP1  = SDLK_KP1;
int _p_sdlk_KP2  = SDLK_KP2;
int _p_sdlk_KP3  = SDLK_KP3;
int _p_sdlk_KP4  = SDLK_KP4;
int _p_sdlk_KP5  = SDLK_KP5;
int _p_sdlk_KP6  = SDLK_KP6;
int _p_sdlk_KP7  = SDLK_KP7;
int _p_sdlk_KP8  = SDLK_KP8;
int _p_sdlk_KP9  = SDLK_KP9;
int _p_sdlk_KP_PERIOD  = SDLK_KP_PERIOD;
int _p_sdlk_KP_DIVIDE  = SDLK_KP_DIVIDE;
int _p_sdlk_KP_MULTIPLY	= SDLK_KP_MULTIPLY;
int _p_sdlk_KP_MINUS  = SDLK_KP_MINUS;
int _p_sdlk_KP_PLUS  = SDLK_KP_PLUS;
int _p_sdlk_KP_ENTER  = SDLK_KP_ENTER;
int _p_sdlk_KP_EQUALS  = SDLK_KP_EQUALS;
int _p_sdlk_UP  = SDLK_UP;
int _p_sdlk_DOWN  = SDLK_DOWN;
int _p_sdlk_RIGHT  = SDLK_RIGHT;
int _p_sdlk_LEFT  = SDLK_LEFT;
int _p_sdlk_INSERT  = SDLK_INSERT;
int _p_sdlk_HOME  = SDLK_HOME;
int _p_sdlk_END  = SDLK_END;
int _p_sdlk_PAGEUP  = SDLK_PAGEUP;
int _p_sdlk_PAGEDOWN  = SDLK_PAGEDOWN;
int _p_sdlk_F1  = SDLK_F1;
int _p_sdlk_F2  = SDLK_F2;
int _p_sdlk_F3  = SDLK_F3;
int _p_sdlk_F4  = SDLK_F4;
int _p_sdlk_F5  = SDLK_F5;
int _p_sdlk_F6  = SDLK_F6;
int _p_sdlk_F7  = SDLK_F7;
int _p_sdlk_F8  = SDLK_F8;
int _p_sdlk_F9  = SDLK_F9;
int _p_sdlk_F10  = SDLK_F10;
int _p_sdlk_F11  = SDLK_F11;
int _p_sdlk_F12  = SDLK_F12;
int _p_sdlk_F13  = SDLK_F13;
int _p_sdlk_F14  = SDLK_F14;
int _p_sdlk_F15  = SDLK_F15;
int _p_sdlk_NUMLOCK  = SDLK_NUMLOCK;
int _p_sdlk_CAPSLOCK  = SDLK_CAPSLOCK;
int _p_sdlk_SCROLLOCK  = SDLK_SCROLLOCK;
int _p_sdlk_RSHIFT  = SDLK_RSHIFT;
int _p_sdlk_LSHIFT  = SDLK_LSHIFT;
int _p_sdlk_RCTRL  = SDLK_RCTRL;
int _p_sdlk_LCTRL  = SDLK_LCTRL;
int _p_sdlk_RALT  = SDLK_RALT;
int _p_sdlk_LALT  = SDLK_LALT;
int _p_sdlk_RMETA  = SDLK_RMETA;
int _p_sdlk_LMETA  = SDLK_LMETA;
int _p_sdlk_LSUPER  = SDLK_LSUPER;
int _p_sdlk_RSUPER  = SDLK_RSUPER;
int _p_sdlk_MODE  = SDLK_MODE;
int _p_sdlk_COMPOSE  = SDLK_COMPOSE;
int _p_sdlk_HELP  = SDLK_HELP;
int _p_sdlk_PRINT  = SDLK_PRINT;
int _p_sdlk_SYSREQ  = SDLK_SYSREQ;
int _p_sdlk_BREAK  = SDLK_BREAK;
int _p_sdlk_MENU  = SDLK_MENU;
int _p_sdlk_POWER  = SDLK_POWER;
int _p_sdlk_EURO  = SDLK_EURO;
int _p_sdlk_UNDO  = SDLK_UNDO;
int _p_sdlk_LAST  = SDLK_LAST;

int _p_kmod_NONE   = KMOD_NONE;
int _p_kmod_LSHIFT = KMOD_LSHIFT;
int _p_kmod_RSHIFT = KMOD_RSHIFT;
int _p_kmod_LCTRL  = KMOD_LCTRL;
int _p_kmod_RCTRL  = KMOD_RCTRL;
int _p_kmod_LALT   = KMOD_LALT;
int _p_kmod_RALT   = KMOD_RALT;
int _p_kmod_LMETA  = KMOD_LMETA;
int _p_kmod_RMETA  = KMOD_RMETA;
int _p_kmod_NUM    = KMOD_NUM;
int _p_kmod_CAPS   = KMOD_CAPS;
int _p_kmod_MODE   = KMOD_MODE;
int _p_kmod_RESERVED= KMOD_RESERVED;
int _p_kmod_CTRL  = KMOD_CTRL;
int _p_kmod_SHIFT = KMOD_SHIFT;
int _p_kmod_ALT   = KMOD_ALT;
int _p_kmod_META  = KMOD_META;

/* From SDL_mouse.h */
int _p_sdl_button_left    = SDL_BUTTON_LEFT;
int _p_sdl_button_middle  = SDL_BUTTON_MIDDLE;
int _p_sdl_button_right   = SDL_BUTTON_RIGHT;
int _p_sdl_button_lmask   = SDL_BUTTON_LMASK;
int _p_sdl_button_mmask   = SDL_BUTTON_MMASK;
int _p_sdl_button_rmask   = SDL_BUTTON_RMASK;
Uint8 _p_sdl_button (Uint8 X)
{
  return (SDL_BUTTON(X));
}

/* From SDL_timer.h */
int _p_sdl_timeslice = SDL_TIMESLICE;
int _p_timer_resolution = TIMER_RESOLUTION;

/* From SDL_types.h */
/* SDL_bool is just boolean, Uint32, Sint8, ... are mapped to the
types of GPC. */
int _p_sdl_pressed          = SDL_PRESSED;
int _p_sdl_released         = SDL_RELEASED;

/* From SDL_version.h */
int _p_sdl_major_version    = SDL_MAJOR_VERSION;
int _p_sdl_minor_version    = SDL_MINOR_VERSION;
int _p_sdl_patchlevel       = SDL_PATCHLEVEL;

/* From SDL_video.h */

int _p_sizeof_sdl_Rect (void)         { return sizeof (SDL_Rect); }
int _p_sizeof_sdl_Color (void)        { return sizeof (SDL_Color); }
int _p_sizeof_sdl_Palette (void)      { return sizeof (SDL_Palette); }
int _p_sizeof_sdl_PixelFormat (void)  { return sizeof (SDL_PixelFormat); }
int _p_sizeof_sdl_Surface (void)      { return sizeof (SDL_Surface); }
int _p_sizeof_sdl_VideoInfo (void)    { return sizeof (SDL_VideoInfo); }
int _p_sizeof_sdl_Overlay (void)      { return sizeof (SDL_Overlay); }
int _p_sizeof_sdl_GLattr (void)       { return sizeof (SDL_GLattr); }
int _p_sizeof_sdl_GrabMode (void)     { return sizeof (SDL_GrabMode); }

int _p_sdl_mustlock (SDL_Surface *sf) { return (SDL_MUSTLOCK (sf)); }

int _p_sdl_ALPHA_OPAQUE = SDL_ALPHA_OPAQUE;
int _p_sdl_ALPHA_TRANSPARENT = SDL_ALPHA_TRANSPARENT;
int _p_sdl_SWSURFACE = SDL_SWSURFACE;
int _p_sdl_HWSURFACE = SDL_HWSURFACE;
int _p_sdl_ASYNCBLIT = SDL_ASYNCBLIT;
int _p_sdl_ANYFORMAT = SDL_ANYFORMAT;
int _p_sdl_HWPALETTE = SDL_HWPALETTE;
int _p_sdl_DOUBLEBUF = SDL_DOUBLEBUF;
int _p_sdl_FULLSCREEN = SDL_FULLSCREEN;
int _p_sdl_OPENGL = SDL_OPENGL;
int _p_sdl_OPENGLBLIT = SDL_OPENGLBLIT;
int _p_sdl_RESIZABLE = SDL_RESIZABLE;
int _p_sdl_NOFRAME = SDL_NOFRAME;
int _p_sdl_HWACCEL = SDL_HWACCEL;
int _p_sdl_SRCCOLORKEY = SDL_SRCCOLORKEY;
int _p_sdl_RLEACCELOK = SDL_RLEACCELOK;
int _p_sdl_RLEACCEL = SDL_RLEACCEL;
int _p_sdl_SRCALPHA = SDL_SRCALPHA;
int _p_sdl_PREALLOC = SDL_PREALLOC;
int _p_sdl_YV12_OVERLAY = SDL_YV12_OVERLAY;
int _p_sdl_IYUV_OVERLAY = SDL_IYUV_OVERLAY;
int _p_sdl_YUY2_OVERLAY = SDL_YUY2_OVERLAY;
int _p_sdl_UYVY_OVERLAY = SDL_UYVY_OVERLAY;
int _p_sdl_YVYU_OVERLAY = SDL_YVYU_OVERLAY;
int _p_sdl_LOGPAL   = SDL_LOGPAL;
int _p_sdl_PHYSPAL  = SDL_PHYSPAL;
int _p_sdl_gl_RED_SIZE          = SDL_GL_RED_SIZE;
int _p_sdl_gl_GREEN_SIZE        = SDL_GL_GREEN_SIZE;
int _p_sdl_gl_BLUE_SIZE         = SDL_GL_BLUE_SIZE;
int _p_sdl_gl_ALPHA_SIZE        = SDL_GL_ALPHA_SIZE;
int _p_sdl_gl_BUFFER_SIZE       = SDL_GL_BUFFER_SIZE;
int _p_sdl_gl_DOUBLEBUFFER      = SDL_GL_DOUBLEBUFFER;
int _p_sdl_gl_DEPTH_SIZE        = SDL_GL_DEPTH_SIZE;
int _p_sdl_gl_STENCIL_SIZE      = SDL_GL_STENCIL_SIZE;
int _p_sdl_gl_ACCUM_RED_SIZE    = SDL_GL_ACCUM_RED_SIZE;
int _p_sdl_gl_ACCUM_GREEN_SIZE  = SDL_GL_ACCUM_GREEN_SIZE;
int _p_sdl_gl_ACCUM_BLUE_SIZE   = SDL_GL_ACCUM_BLUE_SIZE;
int _p_sdl_gl_ACCUM_ALPHA_SIZE  = SDL_GL_ACCUM_ALPHA_SIZE;
int _p_sdl_grab_query       = SDL_GRAB_QUERY;
int _p_sdl_grab_off         = SDL_GRAB_OFF;
int _p_sdl_grab_on          = SDL_GRAB_ON;
int _p_sdl_grab_fullscreen  = SDL_GRAB_FULLSCREEN;

